from .element import Element


class Attribute(Element):

    ABSOLUTE_AREA_SERVICE_NUMBER = 0x1000001000000
    AREA_VERSION = 1
    ATTRIBUTE_AREA_NUMBER = 1
    ATTRIBUTE_SERVICE_NUMBER = 0

    BLOB_TYPE_SHORT_FORM = 1
    BOOLEAN_TYPE_SHORT_FORM = 2
    DURATION_TYPE_SHORT_FORM = 3
    FLOAT_TYPE_SHORT_FORM = 4
    DOUBLE_TYPE_SHORT_FORM = 5
    IDENTIFIER_TYPE_SHORT_FORM = 6
    OCTET_TYPE_SHORT_FORM = 7
    UOCTET_TYPE_SHORT_FORM = 8
    SHORT_TYPE_SHORT_FORM = 9
    USHORT_TYPE_SHORT_FORM = 10
    INTEGER_TYPE_SHORT_FORM = 11
    UINTEGER_TYPE_SHORT_FORM = 12
    LONG_TYPE_SHORT_FORM = 13
    ULONG_TYPE_SHORT_FORM = 14
    STRING_TYPE_SHORT_FORM = 15
    TIME_TYPE_SHORT_FORM = 16
    FINETIME_TYPE_SHORT_FORM = 17
    URI_TYPE_SHORT_FORM = 18

    BLOB_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        BLOB_TYPE_SHORT_FORM
    BOOLEAN_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        BOOLEAN_TYPE_SHORT_FORM
    DURATION_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        DURATION_TYPE_SHORT_FORM
    FLOAT_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        FLOAT_TYPE_SHORT_FORM
    DOUBLE_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        DOUBLE_TYPE_SHORT_FORM
    IDENTIFIER_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        IDENTIFIER_TYPE_SHORT_FORM
    OCTET_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        OCTET_TYPE_SHORT_FORM
    UOCTET_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        UOCTET_TYPE_SHORT_FORM
    SHORT_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        SHORT_TYPE_SHORT_FORM
    USHORT_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        USHORT_TYPE_SHORT_FORM
    INTEGER_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        INTEGER_TYPE_SHORT_FORM
    UINTEGER_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        UINTEGER_TYPE_SHORT_FORM
    LONG_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        LONG_TYPE_SHORT_FORM
    ULONG_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        ULONG_TYPE_SHORT_FORM
    STRING_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        STRING_TYPE_SHORT_FORM
    TIME_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        TIME_TYPE_SHORT_FORM
    FINETIME_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        FINETIME_TYPE_SHORT_FORM
    URI_SHORT_FORM = ABSOLUTE_AREA_SERVICE_NUMBER +\
        URI_TYPE_SHORT_FORM

    def get_short_form(self):
        return self._short_form

    def get_type_short_form(self):
        return self._type_short_form

    def get_area_number(self):
        return Attribute.ATTRIBUTE_AREA_NUMBER

    def get_area_version(self):
        return Attribute.AREA_VERSION

    def get_service_number(self):
        return Attribute.ATTRIBUTE_SERVICE_NUMBER

    def get_value(self):
        return self.value

    def __eq__(self, other):
        if super().__eq__(self, other):
            if self.value == other.value:
                return True
        return False
